## obs-studio 30.1.2

=== deps/blake2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

add_library(blake2 OBJECT)
add_library(OBS::blake2 ALIAS blake2)

target_sources(
  blake2
  PRIVATE src/blake2-impl.h src/blake2b-ref.c
  PUBLIC src/blake2.h)

target_include_directories(blake2 PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/src")

set_target_properties(blake2 PROPERTIES FOLDER deps)

=== plugins/mac-avcapture/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

add_library(mac-avcapture-legacy MODULE)
add_library(OBS::avcapture-legacy ALIAS mac-avcapture-legacy)

target_sources(mac-avcapture-legacy PRIVATE legacy/av-capture.mm legacy/left-right.hpp legacy/scope-guard.hpp)
target_include_directories(mac-avcapture-legacy PRIVATE legacy)

target_link_libraries(
  mac-avcapture-legacy
  PRIVATE OBS::libobs
          "$<LINK_LIBRARY:FRAMEWORK,AVFoundation.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,Cocoa.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreFoundation.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreMedia.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreVideo.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreMediaIO.framework>")

# cmake-format: off
set_target_properties_obs(
  mac-avcapture-legacy
  PROPERTIES FOLDER plugins
             PREFIX ""
             XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC YES
             XCODE_ATTRIBUTE_CLANG_WARN_SUSPICIOUS_IMPLICIT_CONVERSION YES
             XCODE_ATTRIBUTE_GCC_WARN_SHADOW YES)
# cmake-format: on

add_library(mac-avcapture MODULE)
add_library(OBS::avcapture ALIAS mac-avcapture)

target_sources(
  mac-avcapture
  PRIVATE plugin-main.m
          plugin-main.h
          plugin-properties.m
          plugin-properties.h
          OBSAVCapture.m
          OBSAVCapture.h
          OBSAVCapturePresetInfo.m
          OBSAVCapturePresetInfo.h)

target_link_libraries(mac-avcapture PRIVATE OBS::libobs)

# cmake-format: off
set_target_properties_obs(
  mac-avcapture
  PROPERTIES FOLDER plugins
             PREFIX ""
             XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC YES
             XCODE_ATTRIBUTE_CLANG_WARN_SUSPICIOUS_IMPLICIT_CONVERSION YES
             XCODE_ATTRIBUTE_GCC_WARN_SHADOW YES
             XCODE_ATTRIBUTE_CLANG_ENABLE_MODULES YES
             XCODE_ATTRIBUTE_CLANG_MODULES_AUTOLINK YES
             XCODE_ATTRIBUTE_GCC_STRICT_ALIASING YES)


string(TIMESTAMP CURRENT_YEAR "%Y")
set_target_xcode_properties(
  mac-avcapture
  PROPERTIES INFOPLIST_KEY_NSHumanReadableCopyright "(c) 2023-${CURRENT_YEAR} Patrick Heyer")
# cmake-format: on

=== plugins/mac-capture/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

add_library(mac-capture MODULE)
add_library(OBS::capture ALIAS mac-capture)

target_sources(
  mac-capture
  PRIVATE # cmake-format: sortable
          audio-device-enum.c
          audio-device-enum.h
          mac-audio.c
          mac-display-capture.m
          mac-sck-audio-capture.m
          mac-sck-common.h
          mac-sck-common.m
          mac-sck-video-capture.m
          mac-window-capture.m
          plugin-main.c
          window-utils.h
          window-utils.m)

# cmake-format: off
target_link_libraries(
  mac-capture
  PRIVATE OBS::libobs
          "$<LINK_LIBRARY:FRAMEWORK,AudioUnit.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,Cocoa.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreAudio.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreFoundation.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreMedia.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,CoreVideo.framework>"
          "$<LINK_LIBRARY:FRAMEWORK,IOSurface.framework>"
          "$<LINK_LIBRARY:WEAK_FRAMEWORK,ScreenCaptureKit.framework>")

set_target_properties_obs(
  mac-capture
  PROPERTIES FOLDER plugins
             PREFIX ""
             XCODE_ATTRIBUTE_CLANG_WARN_SUSPICIOUS_IMPLICIT_CONVERSION YES
             XCODE_ATTRIBUTE_GCC_WARN_SHADOW YES)
# cmake-format: on

if(CMAKE_VERSION VERSION_LESS_EQUAL 3.25.0)
  set_property(TARGET mac-capture PROPERTY XCODE_LINK_BUILD_PHASE_MODE BUILT_ONLY)
endif()

=== plugins/obs-qsv11/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22...3.25)

legacy_check()

option(ENABLE_QSV11 "Build Intel QSV11 Hardware Encoder." TRUE)
if(NOT ENABLE_QSV11)
  target_disable_feature(obs-qsv11 "Intel QSV11 Hardware Encoder")
  target_disable(obs-qsv11)
  return()
endif()

add_library(obs-qsv11 MODULE)
add_library(OBS::qsv11 ALIAS obs-qsv11)

find_package(VPL 2.6 REQUIRED)

if(OS_LINUX)
  find_package(Libva REQUIRED)
endif()

target_sources(
  obs-qsv11
  PRIVATE # cmake-format: sortable
          $<$<PLATFORM_ID:Linux>:common_utils_linux.cpp>
          $<$<PLATFORM_ID:Windows>:common_directx11.cpp>
          $<$<PLATFORM_ID:Windows>:common_directx11.h>
          $<$<PLATFORM_ID:Windows>:common_utils_windows.cpp>
          common_utils.cpp
          common_utils.h
          obs-qsv11-plugin-main.c
          obs-qsv11.c
          QSV_Encoder.cpp
          QSV_Encoder.h
          QSV_Encoder_Internal.cpp
          QSV_Encoder_Internal.h)

target_compile_definitions(obs-qsv11 PRIVATE $<$<PLATFORM_ID:Windows>:DX11_D3D>)

target_link_libraries(
  obs-qsv11
  PRIVATE OBS::libobs
          VPL::VPL
          $<$<PLATFORM_ID:Linux>:Libva::va>
          $<$<PLATFORM_ID:Linux>:Libva::drm>
          $<$<PLATFORM_ID:Windows>:d3d11>
          $<$<PLATFORM_ID:Windows>:dxgi>
          $<$<PLATFORM_ID:Windows>:dxguid>)

target_link_options(obs-qsv11 PRIVATE $<$<PLATFORM_ID:Windows>:/IGNORE:4099>)

if(OS_WINDOWS)
  add_subdirectory(obs-qsv-test)

  configure_file(cmake/windows/obs-module.rc.in obs-qsv11.rc)
  target_sources(obs-qsv11 PRIVATE obs-qsv11.rc)
endif()

# cmake-format: off
set_target_properties_obs(obs-qsv11 PROPERTIES FOLDER plugins/obs-qsv11 PREFIX "")
# cmake-format: on

=== plugins/win-capture/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
  add_library(hook-config INTERFACE)
  add_library(OBS::hook-config ALIAS hook-config)
  target_sources(hook-config INTERFACE graphics-hook-ver.h graphics-hook-info.h hook-helpers.h)
  target_include_directories(hook-config INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

  add_library(inject-library INTERFACE)
  add_library(OBS::inject-library ALIAS inject-library)
  target_sources(inject-library INTERFACE inject-library.c inject-library.h)
  target_include_directories(inject-library INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

  add_library(d3d8-api INTERFACE)
  add_library(OBS::d3d8-api ALIAS d3d8-api)
  target_sources(d3d8-api INTERFACE d3d8-api/d3d8.h d3d8-api/d3d8caps.h d3d8-api/d3d8types.h)
  target_include_directories(d3d8-api INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/d3d8-api")
endif()

legacy_check()

option(ENABLE_COMPAT_UPDATES "Checks for capture compatibility data updates" ON)

# cmake-format: off
set(COMPAT_URL "https://obsproject.com/obs2_update/win-capture" CACHE STRING "Default services package URL")
mark_as_advanced(COMPAT_URL)
# cmake-format: on

if(NOT TARGET OBS::ipc-util)
  add_subdirectory("${CMAKE_SOURCE_DIR}/deps/ipc-util" "${CMAKE_BINARY_DIR}/deps/ipc-util")
endif()

if(NOT TARGET OBS::file-updater)
  add_subdirectory("${CMAKE_SOURCE_DIR}/deps/file-updater" "${CMAKE_BINARY_DIR}/deps/file-updater")
endif()

find_package(jansson REQUIRED)

add_library(win-capture MODULE)
add_library(OBS::capture ALIAS win-capture)

target_sources(
  win-capture
  PRIVATE # cmake-format: sortable
          app-helpers.c
          app-helpers.h
          audio-helpers.c
          audio-helpers.h
          compat-format-ver.h
          compat-helpers.c
          compat-helpers.h
          cursor-capture.c
          cursor-capture.h
          dc-capture.c
          dc-capture.h
          duplicator-monitor-capture.c
          game-capture-file-init.c
          game-capture.c
          load-graphics-offsets.c
          monitor-capture.c
          nt-stuff.c
          nt-stuff.h
          plugin-main.c
          window-capture.c)

target_compile_definitions(
  win-capture PRIVATE COMPAT_URL="${COMPAT_URL}" "$<$<BOOL:${ENABLE_COMPAT_UPDATES}>:ENABLE_COMPAT_UPDATES>"
                      OBS_VERSION="${OBS_VERSION_CANONICAL}")

target_link_libraries(
  win-capture
  PRIVATE OBS::file-updater
          OBS::hook-config
          OBS::inject-library
          OBS::ipc-util
          OBS::libobs
          OBS::obfuscate
          OBS::w32-pthreads
          OBS::winrt-headers
          jansson::jansson)

# Remove once jansson has been fixed on obs-deps
target_link_options(win-capture PRIVATE /IGNORE:4098)

# cmake-format: off
set_target_properties_obs(win-capture PROPERTIES FOLDER plugins/win-capture PREFIX "")
# cmake-format: on

add_subdirectory(graphics-hook)
add_subdirectory(get-graphics-offsets)
add_subdirectory(inject-helper)

=== plugins/win-dshow/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
  add_library(obs-virtualcam-interface INTERFACE)
  add_library(OBS::virtualcam-interface ALIAS obs-virtualcam-interface)

  target_sources(obs-virtualcam-interface INTERFACE shared-memory-queue.c shared-memory-queue.h tiny-nv12-scale.c
                                                    tiny-nv12-scale.h)
  target_include_directories(obs-virtualcam-interface INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

  include(cmake/libdshowcapture.cmake)
  add_subdirectory(virtualcam-module)
endif()

legacy_check()

find_package(FFmpeg REQUIRED avcodec avutil)

add_library(win-dshow MODULE)
add_library(OBS::dshow ALIAS win-dshow)

target_sources(
  win-dshow
  PRIVATE # cmake-format: sortable
          dshow-plugin.cpp encode-dstr.hpp ffmpeg-decode.c ffmpeg-decode.h win-dshow-encoder.cpp win-dshow.cpp)

configure_file(cmake/windows/obs-module.rc.in win-dshow.rc)
target_sources(win-dshow PRIVATE win-dshow.rc)

target_link_libraries(
  win-dshow
  PRIVATE OBS::libobs
          OBS::w32-pthreads
          OBS::libdshowcapture
          FFmpeg::avcodec
          FFmpeg::avutil
          strmiids
          winmm)

if(TARGET OBS::virtualcam AND TARGET OBS::virtualcam-guid)
  target_sources(win-dshow PRIVATE virtualcam.c)
  target_link_libraries(win-dshow PRIVATE OBS::virtualcam-interface OBS::virtualcam-guid)
  target_compile_definitions(win-dshow PRIVATE VIRTUALCAM_AVAILABLE)

  add_dependencies(win-dshow obs-virtualcam-module)
endif()

# cmake-format: off
set_target_properties_obs(win-dshow PROPERTIES FOLDER plugins/win-dshow PREFIX "")
# cmake-format: on

=== plugins/win-wasapi/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

legacy_check()

add_library(win-wasapi MODULE)
add_library(OBS::wasapi ALIAS win-wasapi)

target_sources(win-wasapi PRIVATE win-wasapi.cpp wasapi-notify.cpp wasapi-notify.hpp enum-wasapi.cpp enum-wasapi.hpp
                                  plugin-main.cpp)

configure_file(cmake/windows/obs-module.rc.in win-wasapi.rc)
target_sources(win-wasapi PRIVATE win-wasapi.rc)

target_link_libraries(win-wasapi PRIVATE OBS::libobs Avrt)

# cmake-format: off
set_target_properties_obs(win-wasapi PROPERTIES FOLDER plugins PREFIX "")
# cmake-format: on

=== plugins/obs-qsv11/obs-qsv-test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

legacy_check()

add_executable(obs-qsv-test)

find_package(VPL 2.6 REQUIRED)

target_sources(obs-qsv-test PRIVATE obs-qsv-test.cpp)

target_compile_definitions(obs-qsv-test PRIVATE "$<$<BOOL:${ENABLE_HEVC}>:ENABLE_HEVC>")

target_link_libraries(obs-qsv-test d3d11 dxgi dxguid VPL::VPL OBS::COMutils)

target_link_options(obs-qsv-test PRIVATE /IGNORE:4099)

# cmake-format: off
set_target_properties_obs(obs-qsv-test PROPERTIES FOLDER plugins/obs-qsv11 PREFIX "")
# cmake-format: on

=== plugins/win-capture/get-graphics-offsets/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

add_library(_get-graphics-offsets INTERFACE)
target_sources(_get-graphics-offsets INTERFACE d3d8-offsets.cpp d3d9-offsets.cpp dxgi-offsets.cpp
                                               get-graphics-offsets.c get-graphics-offsets.h)

target_link_libraries(_get-graphics-offsets INTERFACE OBS::hook-config OBS::d3d8-api d3d9.lib dxgi.lib d3d11.lib)

legacy_check()

add_executable(get-graphics-offsets)
target_link_libraries(get-graphics-offsets PRIVATE _get-graphics-offsets)

include(cmake/32bit.cmake)

# cmake-format: off
set_target_properties_obs(get-graphics-offsets PROPERTIES FOLDER plugins/win-capture OUTPUT_NAME get-graphics-offsets64 MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
# cmake-format: on

add_dependencies(win-capture get-graphics-offsets)

=== plugins/win-capture/graphics-hook/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

find_package(Detours REQUIRED)
find_package(Vulkan REQUIRED)

if(NOT TARGET OBS::ipc-util)
  add_subdirectory("${CMAKE_SOURCE_DIR}/deps/ipc-util" "${CMAKE_BINARY_DIR}/deps/ipc-util")
endif()

if(NOT TARGET OBS::obfuscate)
  add_subdirectory("${CMAKE_SOURCE_DIR}/libobs" "${CMAKE_BINARY_DIR}/libobs")
endif()

add_library(_graphics-hook INTERFACE)

target_sources(
  _graphics-hook
  INTERFACE # cmake-format: sortable
            d3d10-capture.cpp
            d3d11-capture.cpp
            d3d12-capture.cpp
            d3d8-capture.cpp
            d3d9-capture.cpp
            d3d9-patches.hpp
            dxgi-capture.cpp
            gl-capture.c
            gl-decs.h
            graphics-hook.c
            graphics-hook.h
            graphics-hook.rc)

target_compile_definitions(_graphics-hook INTERFACE COMPILE_D3D12_HOOK)

target_link_libraries(_graphics-hook INTERFACE OBS::d3d8-api OBS::hook-config OBS::ipc-util OBS::obfuscate
                                               Detours::Detours dxguid)

target_link_options(_graphics-hook INTERFACE /IGNORE:4099)

if(TARGET Vulkan::Vulkan)
  target_sources(_graphics-hook INTERFACE vulkan-capture.c vulkan-capture.h)
  target_link_libraries(_graphics-hook INTERFACE Vulkan::Vulkan)
  target_compile_definitions(_graphics-hook INTERFACE COMPILE_VULKAN_HOOK)
endif()

legacy_check()

add_library(graphics-hook MODULE)
add_library(OBS::graphics-hook ALIAS graphics-hook)

target_link_libraries(graphics-hook PRIVATE _graphics-hook)

include(cmake/32bit.cmake)

# cmake-format: off
set_target_properties_obs(graphics-hook PROPERTIES FOLDER "plugins/win-capture" OUTPUT_NAME graphics-hook64 MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
# cmake-format: on

add_dependencies(win-capture graphics-hook)

=== plugins/win-capture/inject-helper/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

if(NOT TARGET OBS::obfuscate)
  add_subdirectory("${CMAKE_SOURCE_DIR}/libobs" "${CMAKE_BINARY_DIR}/libobs")
endif()

add_library(_inject-helper INTERFACE)

target_sources(_inject-helper INTERFACE inject-helper.c)

target_link_libraries(_inject-helper INTERFACE OBS::inject-library OBS::obfuscate)

legacy_check()

add_executable(inject-helper)
target_link_libraries(inject-helper PRIVATE _inject-helper)

include(cmake/32bit.cmake)

# cmake-format: off
set_target_properties_obs(inject-helper PROPERTIES FOLDER plugins/win-capture OUTPUT_NAME inject-helper64 MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
# cmake-format: on

add_dependencies(win-capture inject-helper)

=== plugins/win-dshow/virtualcam-module/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
  option(ENABLE_VIRTUALCAM "Enable Windows Virtual Camera" ON)
  if(NOT ENABLE_VIRTUALCAM)
    target_disable_feature(obs-virtualcam-module "Virtual Camera Support")
    target_disable(obs-virtualcam-module)
    return()
  endif()

  if(NOT VIRTUALCAM_GUID)
    # cmake-format: off
    set(VIRTUALCAM_GUID "" CACHE STRING "Virtual Camera GUID" FORCE)
    mark_as_advanced(VIRTUALCAM_GUID)
    # cmake-format: on

    message(WARNING "Empty Virtual Camera GUID set.")
    target_disable_feature(obs-virtualcam-module "Virtual Camera Support (empty GUID)")
    return()
  else()
    set(VALID_GUID FALSE)
    check_uuid(${VIRTUALCAM_GUID} VALID_GUID)

    if(NOT VALID_GUID)
      message(WARNING "Invalid Virtual Camera GUID set.")
      target_disable_feature(obs-virtualcam-module "Virtual Camera Support (invalid GUID)")
      return()
    endif()

    # DirectShow API requires separate GUID tokens
    string(REPLACE "-" ";" GUID_VALS ${VIRTUALCAM_GUID})
    list(GET GUID_VALS 0 GUID_VALS_DATA1)
    list(GET GUID_VALS 1 GUID_VALS_DATA2)
    list(GET GUID_VALS 2 GUID_VALS_DATA3)
    list(GET GUID_VALS 3 GUID_VALS_DATA4)
    list(GET GUID_VALS 4 GUID_VALS_DATA5)
    set(GUID_VAL01 ${GUID_VALS_DATA1})
    set(GUID_VAL02 ${GUID_VALS_DATA2})
    set(GUID_VAL03 ${GUID_VALS_DATA3})
    string(SUBSTRING ${GUID_VALS_DATA4} 0 2 GUID_VAL04)
    string(SUBSTRING ${GUID_VALS_DATA4} 2 2 GUID_VAL05)
    string(SUBSTRING ${GUID_VALS_DATA5} 0 2 GUID_VAL06)
    string(SUBSTRING ${GUID_VALS_DATA5} 2 2 GUID_VAL07)
    string(SUBSTRING ${GUID_VALS_DATA5} 4 2 GUID_VAL08)
    string(SUBSTRING ${GUID_VALS_DATA5} 6 2 GUID_VAL09)
    string(SUBSTRING ${GUID_VALS_DATA5} 8 2 GUID_VAL10)
    string(SUBSTRING ${GUID_VALS_DATA5} 10 2 GUID_VAL11)
  endif()

  add_library(obs-virtualcam-guid INTERFACE)
  add_library(OBS::virtualcam-guid ALIAS obs-virtualcam-guid)

  configure_file(virtualcam-guid.h.in virtualcam-guid.h)
  target_sources(obs-virtualcam-guid INTERFACE "${CMAKE_CURRENT_BINARY_DIR}/virtualcam-guid.h")
  target_include_directories(obs-virtualcam-guid INTERFACE "${CMAKE_CURRENT_BINARY_DIR}")

  add_library(_virtualcam INTERFACE)

  configure_file(cmake/windows/obs-module.rc.in virtualcam-module.rc)
  target_sources(
    _virtualcam
    INTERFACE # cmake-format: sortable
              ${CMAKE_CURRENT_BINARY_DIR}/virtualcam-module.rc
              placeholder.cpp
              sleepto.c
              sleepto.h
              virtualcam-filter.cpp
              virtualcam-filter.hpp
              virtualcam-module.cpp)
  target_include_directories(_virtualcam INTERFACE "${CMAKE_CURRENT_BINARY_DIR}")
  target_compile_definitions(_virtualcam INTERFACE VIRTUALCAM_AVAILABLE)

  target_link_libraries(
    _virtualcam
    INTERFACE OBS::virtualcam-interface
              OBS::virtualcam-guid
              OBS::libdshowcapture
              OBS::winhandle
              gdiplus
              strmiids
              winmm)
endif()

legacy_check()

add_library(obs-virtualcam-module MODULE)
add_library(OBS::virtualcam ALIAS obs-virtualcam-module)

target_sources(obs-virtualcam-module PRIVATE cmake/windows/virtualcam-module64.def)
target_link_libraries(obs-virtualcam-module PRIVATE _virtualcam)

set_property(TARGET obs-virtualcam-module PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")

configure_file(virtualcam-install.bat.in virtualcam-install.bat)
target_add_resource(obs-virtualcam-module "${CMAKE_CURRENT_BINARY_DIR}/virtualcam-install.bat"
                    "${OBS_DATA_DESTINATION}/obs-plugins/win-dshow")

configure_file(virtualcam-uninstall.bat.in virtualcam-uninstall.bat)
target_add_resource(obs-virtualcam-module "${CMAKE_CURRENT_BINARY_DIR}/virtualcam-uninstall.bat"
                    "${OBS_DATA_DESTINATION}/obs-plugins/win-dshow")

include(cmake/32bit.cmake)

# cmake-format: off
set_target_properties_obs(obs-virtualcam-module PROPERTIES FOLDER plugins/win-dshow OUTPUT_NAME obs-virtualcam-module64)
# cmake-format: on

=== debian/changelog ===
obs-studio (30.1.2-0.nmu1) UNRELEASED; urgency=medium

  * Non-maintainer upload.
  * new upstream version 30.1.2
  * debian-patches/:
    skip 0006-Do-not-build-unused-blake2-dependency.patch
    skip 0013-Fix-comparision-if-char-is-unsigned.patch
  * disable:
    DeckLink
    JACK

 -- Roman Vasiyarov <rvasiyarov@gmail.com>  Sat, 27 Apr 2024 23:24:00 +0300

=== debian/control ===
Source: obs-studio
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Carl Fürstenberg <azatoth@gmail.com>,
 Sebastian Ramacher <sramacher@debian.org>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 dh-sequence-scour,
 dpkg-dev (>= 1.22.5),
 gir1.2-rsvg-2.0,
 libasio-dev,
 libasound2-dev,
 libavcodec-dev,
 libavdevice-dev,
 libavfilter-dev,
 libavformat-dev,
 libavutil-dev,
 libcmocka-dev,
 libcurl4-gnutls-dev | libcurl-dev,
 libdbus-1-dev,
 libdrm-dev,
 libegl-dev,
 libffmpeg-nvenc-dev,
 libfontconfig-dev,
 libfreetype-dev,
 libglvnd-dev,
 libjack-jackd2-dev,
 libjansson-dev,
 libluajit-5.1-dev,
 libmbedtls-dev,
 libopengl-dev,
 libpci-dev,
 libpipewire-0.3-dev,
 libpulse-dev,
 libqrcodegencpp-dev,
 librist-dev,
 libsimde-dev,
 libspeexdsp-dev,
 libsrt-openssl-dev,
 libswresample-dev,
 libswscale-dev,
 libudev-dev,
 libv4l-dev,
 libva-dev,
 libvlc-dev,
 libvpl-dev [amd64],
 libwayland-dev,
 libwebsocketpp-dev,
 libx11-dev,
 libx11-xcb-dev,
 libx264-dev,
 libxcb-composite0-dev,
 libxcb-randr0-dev,
 libxcb-shm0-dev,
 libxcb-xfixes0-dev,
 libxcb-xinerama0-dev,
 libxcb-xinput-dev,
 libxcb1-dev,
 libxcomposite-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxss-dev,
 ninja-build,
 nlohmann-json3-dev,
 python3-dev,
 python3-docutils,
 python3-gi-cairo,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-svg-dev,
 swig,
Standards-Version: 4.6.2
Homepage: https://obsproject.com
Vcs-Browser: https://salsa.debian.org/multimedia-team/obs-studio
Vcs-Git: https://salsa.debian.org/multimedia-team/obs-studio.git
Rules-Requires-Root: no

Package: obs-studio
Architecture: any
Depends:
 qt6-image-formats-plugins,
 qt6-wayland,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 obs-plugins (= ${binary:Version}),
Suggests:
 pkexec | policykit-1,
 v4l2loopback-dkms,
Breaks:
 obs-websocket (<< 4.9.0-2.1~),
Replaces:
 obs-websocket (<< 4.9.0-2.1~),
Description: recorder and streamer for live video content
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 Other features include:
  * Encoding using H264 (x264) and AAC
  * Unlimited number of scenes and sources
  * File output to MP4 or FLV
  * GPU-based game capture for high performance game streaming
  * Bilinear or lanczos3 resampling
 .
 Note that OBS Studio requires an OpenGL 3.2 compatible video card.

Package: obs-plugins
Architecture: any
Built-Using:
 ${simde:Built-Using},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 vlc,
Multi-Arch: same
Description: recorder and streamer for live video content (plugins)
 OBS Studio is designed for efficiently recording and streaming live
 video content. It supports live RTP streaming to various streaming sites.
 .
 This package contains some extra plugins (ALSA, JACK, PipeWire, DeckLink,
 VLC).

Package: libobs0t64
Provides:
 ${t64:Provides},
Replaces:
 libobs0,
Breaks:
 libobs0 (<< ${source:Version}),
Multi-Arch: same
Section: libs
Architecture: any
Built-Using:
 ${simde:Built-Using},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: recorder and streamer for live video content (shared library)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the shared library libobs.

Package: libobs-dev
Section: libdevel
Architecture: any
Depends:
 libobs0t64 (= ${binary:Version}),
 libsimde-dev,
 libx11-dev,
 ${misc:Depends},
Description: recorder and streamer for live video content (development files)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

CONFIG=None

export DEB_CPPFLAGS_MAINT_APPEND=-DFFMPEG_MUX_FIXED=\"/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg/obs-ffmpeg-mux\"
deb_cflags+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3 -fvisibility=hidden
deb_cflags+=-Wno-error=deprecated-declarations

confflags  =
confflags += -G Ninja
confflags += -DOBS_MULTIARCH_SUFFIX=/$(DEB_HOST_MULTIARCH)
confflags += -DOBS_VERSION_OVERRIDE=$(subst +dfsg,.1,$(DEB_VERSION))
confflags += -DAPPDATA_RELEASE_DATE=$(shell date --utc --date=@$${SOURCE_DATE_EPOCH} +'%Y-%m-%d')
confflags += -DUNIX_STRUCTURE=TRUE
confflags += -DCMAKE_SKIP_RPATH=TRUE
confflags += -DDISABLE_UPDATE_MODULE=TRUE
confflags += -DBUILD_TESTS=TRUE -DENABLE_UNIT_TESTS=TRUE
confflags += -DENABLE_AJA=FALSE
confflags += -DENABLE_DECKLINK=FALSE
confflags += -DENABLE_JACK=FALSE
confflags += -DENABLE_PIPEWIRE=TRUE
confflags += -DENABLE_SNDIO=FALSE
confflags += -DENABLE_VST=FALSE
confflags += -DENABLE_WEBRTC=FALSE

ifeq ($(DEB_HOST_ARCH_CPU), i386)
confflags += -DENABLE_SIMD=FALSE
deb_cflags+=-Wno-error=psabi
endif
DEB_CFLAGS_MAINT_APPEND+=$(deb_cflags)
DEB_CPPFLAGS_MAINT_APPEND+=$(deb_cflags)


BUILDDIR=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)
%:
	dh $@ --builddirectory=$(BUILDDIR)

execute_before_dh_auto_configure:
	cp -r websocket plugins/obs-websocket
	mkdir -p plugins/obs-websocket/deps
	cp -r debian/extra/qr plugins/obs-websocket/deps/
	-find plugins/obs-websocket/ -name ".git*" -exec rm -rf {} +
override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

execute_before_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: .* -c /usr/share/cmake-[0-9.]*/Modules/CMakeCXXCompilerABI\.cpp .*'

execute_after_dh_auto_build:
	rst2man debian/obs.rst > debian/obs.1


override_dh_auto_test:
	LD_LIBRARY_PATH=$(BUILDDIR)/rundir/$(CONFIG)/lib/$(DEB_HOST_MULTIARCH) dh_auto_test

execute_after_dh_auto_install:
	-find debian/tmp -type f -name "*.pem" -exec chmod a-x {} +
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg
	mv debian/tmp/usr/bin/obs-ffmpeg-mux \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg/obs-ffmpeg-mux
execute_after_dh_install:
	rm -rf debian/obs-studio/usr/share/obs/obs-studio/license

execute_before_dh_shlibdeps:
	echo "libobs 0 libobs0t64 (= $(DEB_VERSION))" > debian/shlibs.local

override_dh_python3:
	dh_python3 -p obs-studio usr/share/obs/obs-plugins/frontend-tools/scripts
	dh_python3 -p obs-studio usr/lib/$(DEB_HOST_MULTIARCH)/obs-scripting

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

################################################################
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
	debian/.*|.*\.ttf|.*\.png|cmake/macos/resources/AppIcon.icns|cmake/macos/resources/background.tiff|UI/cmake/windows/obs-studio\.ico
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints
